/**
 * JASMINe
 * Copyright (C) 2008 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: MyDelegate.as 7425 2011-01-12 09:51:31Z durieuxp $
 * --------------------------------------------------------------------------
 */
package org.ow2.jasmine.monitoring.eos.monitoring.business
{
    import com.adobe.cairngorm.business.ServiceLocator;

    import mx.collections.ArrayCollection;
    import mx.controls.Alert;

    import org.ow2.jasmine.kerneos.common.business.AbsDelegateResponder;
    import org.ow2.jasmine.monitoring.eos.monitoring.vo.ConfigFile;
    import org.ow2.jasmine.monitoring.eos.monitoring.vo.Serie;

    /**
     * @author Philippe Durieux
     */
    public class MyDelegate extends AbsDelegateResponder
    {
        private var service:Object=null;

        public function MyDelegate()
        {
            super();
            // Get the Service: See id in kerneos-config.xml
            service=ServiceLocator.getInstance().getRemoteObject("monitoringService");
            if (service == null)
            {
                Alert.show("Cannot get monitoringService", "ERROR");
            }
        }

        public function getReplayFilenames(filter:String):void
        {
            var call:Object=service.getReplayFilenames(filter);
            call.addResponder(this.responder);
        }

        public function getConfigFiles(filter:String):void
        {
            var call:Object=service.getConfigFiles(filter);
            call.addResponder(this.responder);
        }

        public function loadConfigFile(file:String):void
        {
            var call:Object=service.loadConfigFile(file);
            call.addResponder(this.responder);
        }

        public function saveConfigFile(name:String, file:String):void
        {
            var call:Object=service.saveConfigFile(name, file);
            call.addResponder(this.responder);
        }

        public function removeConfigFile(file:ConfigFile):void
        {
            var call:Object=service.removeConfigFile(file);
            call.addResponder(this.responder);
        }

        public function renameConfigFile(file:ConfigFile, name:String):void
        {
            var call:Object=service.renameConfigFile(file, name);
            call.addResponder(this.responder);
        }

        public function loadLogFile(file:String, series:ArrayCollection):void
        {
            var call:Object=service.loadLogFile(file, series);
            call.addResponder(this.responder);
        }

        public function loadFromDataBase(from:Date, to:Date, series:ArrayCollection):void
        {
            var call:Object=service.loadFromDataBase(from, to, series);
            call.addResponder(this.responder);
        }

        public function startMonitoring(series:ArrayCollection):void
        {
            var call:Object=service.startMonitoring(series);
            call.addResponder(this.responder);
        }

        public function stopMonitoring():void
        {
            var call:Object=service.stopMonitoring();
            call.addResponder(this.responder);
        }


    }
}
